<a href="https://opensource.org/licenses/MIT" target="_blank">
  <img src="https://img.shields.io/badge/License-MIT-yellow.svg"/>
</a>
<a href="https://saythanks.io/to/bhoominn%40gmail.com" target="_blank">
  <img src="https://img.shields.io/badge/Say%20Thanks-!-1EAEDB.svg"/>
</a>
<a href="https://opensource.org/licenses/Apache-2.0" target="_blank">
  <img src="https://badges.frapsoft.com/os/v1/open-source.svg?v=102"/>
</a>

## Show some love and like to support the project

## Intro
This package helps you daily usable function with ease. Just add nb_utils with its latest version and that's it you are ready to use.

## Documentation

[API Docs](https://pub.dev/documentation/nb_utils/latest/) are available.

## Installation

add this line to pubspec.yaml

```yaml

   dependencies:
     nb_utils: <latest_version>

```

import package

```dart

    import 'package:nb_utils/nb_utils.dart';

```

## Examples

```dart

    // Open a new screen
    HomePage().launch(context);

    // Remove all screens from back stack and opens new screen
    launchNewScreenWithNewTask(context, 'tag');

    // Back to previous screen
    finish(context);

    // Get Color from hex string
    Color color = getColorFromHex('#FFFFF');
    
    // Hide soft keyboard
    hideKeyboard(context);
    
    // Padding All, Apply TextStyle
    Column(
      children: <Widget>[
         Text(item.title.validate(), style: boldTextStyle()),
      ],
    ).paddingAll(16)
    
    // Check given String is not null
    // validate() function verifies weather given String is null or not. if null then it returns blank String
    // validate() function prevents null object
    Text(item.title.validate()),
      
    // Apply Bold TextStyle
    Text(item.title.validate(), style: boldTextStyle())
    
    // Apply Primary TextStyle
    Text(item.title.validate(), style: primaryTextStyle())
    
    // Apply Secondary TextStyle
    Text(item.title.validate(), style: secondaryTextStyle())
    
    // Rounded Image
    Image.network(item.image, height: 250).cornerRadiusWithClipRRect(20)
    
    // Show a Widget (for ex here Circular Progress Bar) only if data is loading or doing some background task
    Center(child: CircularProgressIndicator()).visible(mIsLoading) 
    * mIsLoading is bool variable.
    
    // Center Widget
    CircularProgressIndicator().center() 
    
    // Apply Default Shadow to a Container Widget
    Container(
      height: 100,
      color: Colors.white,
    ).withShadow()
    
    // Apply Rounded Corner Radius to a Container Widget
    Container(
      height: 100,
      color: Colors.white,
    ).withRoundedCorners()
    
    // Click on ANY Widget
    Container(
      height: 100,
    ).onTap(() {
      // Handle Click
    })
    
    // Print a String
    'This is simple string to print'.log();
    
    // Check Email Validation
    if(!emailController.text.validateEmail()) { 
      // Handle Email not valid
    } 
    
    // Check Phone Number Validation
    if(!phoneController.text.validatePhone()) {
      // Handle Phone Number not valid
    }
    
    // Capitalize First Letter
    'this is simple string'.capitalizeFirstLetter();
    
```

## Bonus ( Android Studio (Eclipse Keymap) Most Needed Shortcuts)

1. ALT + INSERT -> To Create a new File -> Open Project Window on Left Sidebar and press ALT + INSERT key to where you want to create new file. (After opening a window you can also search by typing keyword)

2. CTRL + H -> To find something anywhere in project

3. Scroll from source -> Locate a file in project (GIF)

![](https://2zqt9w.dm.files.1drv.com/y4mZ_iQzS8AgVFKT6LdBSXkuTcbWlmNeJi0QEUkIOYgwNZurxkuXPTFY6xgAFkKFg-nUPshabBV9icQETmZV8HvO8XAffUKNPUrh12n0Zj_WPYM3YB_ExzIBT5R4UVaLjhRZnLm7WyRFICb2Z2VAEZztWg3GiImm_27-kc8x4aGM04V29eKZhZZ5h0lbGXRoZyRIMIYNT6Z5gDz9ug1UxaS_g/ScrollSourceGIF.gif?psid=1)

4. SHIFT + ALT + R -> Rename any variable or file name everywhere you used the same

## 💰 Donations

If you would like to support the creator of this library or the continuous maintenance of this library, feel free to donate. Your donation is highly appreciated. Thank you!

**PayPal**

- **[Donate \$5](https://www.paypal.me/bhoomin/5)**: Thank's for creating this project, here's a tea for you!
- **[Donate \$10](https://www.paypal.me/bhoomin/10)**: Wow, I am stunned. Let me take you to the movies!
- **[Donate \$15](https://www.paypal.me/bhoomin/15)**: I really appreciate your work, let's grab some lunch!
- **[Donate \$25](https://www.paypal.me/bhoomin/25)**: That's some awesome stuff you did right there, dinner is on me!
- **[Donate \$50](https://www.paypal.me/bhoomin/50)**: I really really want to support this project, great job!
- **[Donate \$100](https://www.paypal.me/bhoomin/100)**: You are the man! This project saved me hours of struggle and hard work, simply awesome!

## Getting Started

For help getting started with Flutter, view our online [documentation](https://flutter.dev/).

For help on editing package code, view the [documentation](https://flutter.dev/developing-packages/).
